#include <iostream>
#include <cstdio>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <utility>
#include <list>

using namespace std;


bool compare (const pair < int , int > &a, const pair < int , int > &b)
{
	if (a.first == b.first)
		return a.second > b.second;

	return (a.first > b.first);
}

void calc()
{
	int result = 0;
//	cout << "---" << endl;
	int n;

	cin >> n;

	vector < pair < int , int > > a(n);

	for (int i = 0; i < n ;++i)
		cin >> a[i].first >> a[i].second;
	
	sort(a.begin(), a.end(), compare);

	vector < bool > b(n, true);

	int currtime = a.front().first;

	for (int i = 0; (i < n) && (currtime > 0); )
	{
		int maxindex = -1;

		for (int j = i; j < n; ++j)
			if (b[j] && a[j].first >= currtime)
			{
				if (maxindex == -1)
					maxindex = j;
				else
					if (a[j].second > a[maxindex].second)
						maxindex = j;
			}

		if (maxindex == -1)
		{
			for (int j = i + 1; j < n; ++j)
				if (b[j])
				{
					currtime = a[j].first;
					break;
				}

			continue;
		}
//		cout << maxindex << ", " << currtime << endl;

		result += a[maxindex].second;
		b[maxindex] = false;
		--currtime;
	}

//	for (int i = 0; i < n; ++i)
//		cout << a[i].first << " " << a[i].second << endl;
	
	cout << result << endl;
}

int main ()
{
	freopen("graphic.in", "r", stdin);

	int n;

	cin >> n;

	for (int i = 0; i < n; ++i)
		calc();

	return 0;
}