import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;

public class Main {
	public static void main(String[] args) throws Exception {
		BufferedReader in = new BufferedReader(new FileReader(new File("BUS.in")));
		int t = Integer.parseInt(in.readLine());
		
		for (int q = 0 ; q < t ; q++) {
			String[] data;
			
			data = in.readLine().split(" ");
			
			int n = Integer.parseInt(data[0]);
			int m = Integer.parseInt(data[1]);
			
			int[] d = new int[n];
			int[] l = new int[n + 1];
			int[] h = new int[n];
			
			for (int i = 0 ; i < n ; i++) {
				data = in.readLine().split(" ");
				
				d[i] = Integer.parseInt(data[0]);
				l[i] = Integer.parseInt(data[1]);
				h[i] = Integer.parseInt(data[2]);
			}
			
			double[] time = new double[n + 1];
			l[n] = m;
			for (int i = 0 ; i < n ; i++) {
				if (l[i] <= m) {
					for (int j = 0 ; j < n ; j++) {
						double D = d[j], L = l[i], H = h[j];
						time[i] += D / L + (l[i] > l[j] ? H : 0);  
					}
				} else {
					time[i] = Double.MAX_VALUE;
				}
			}
			
			for (int j = 0 ; j < n ; j++) {
				double D = d[j], H = h[j], M = m;
				time[n] += D  / M + (m > l[j] ? H : 0);
			}
			
			double answer = Double.MAX_VALUE;
			int answerInd = -1;
			int answerSpeed = 0;
			for (int i = 0 ; i <= n ; i++) {
				if (time[i] < answer) {
					answer = time[i];
					answerInd = i;
					answerSpeed = l[i];
				}
				else if (time[i] == answer){
					if (l[i] >= answerSpeed)
						answerSpeed = l[i];
				}
			}
		/*	
			if (time[n] < answer) {
				System.out.println(m);
			} else {
				System.out.println(l[answerInd]);
			}
			*/
			System.out.println(answerSpeed);
		}
	}
}
