
#include "stdlib.h"
#include "stdio.h"
#include "conio.h"
#include "iostream"
#include "vector"
#define MAXN 101
using namespace std;

vector<int> gt[MAXN];
vector<bool> used;
int n;
vector<int> mt;

bool try_kuhn(int v){
	if(used[v]==true)
		return false;
	used[v]=true;
	for(int i=0;i<gt[v].size();i++){
		int to=gt[v][i];
		if(mt[to]==-1 || try_kuhn(to)){
			mt[to]=v;
			return true;
		}
	}
	return false;
}

int main(){
	int T;
	FILE *fp=fopen("IGUANA.IN","r");
	fscanf(fp,"%i",&T);
	for(int it=0;it<T;it++){
		int i,j;
		used.clear();
		mt.clear();
		for(i=0;i<n;i++)
			gt[i].clear();
		fscanf(fp,"%i",&n);
		for(i=0;i<n;i++)
			for(j=0;j<n;j++){
				int t;
				fscanf(fp,"%i",&t);
				if(j>=i && t==0){
					gt[i].push_back(j);
					gt[j].push_back(i);
				}
			}
		mt.assign(n,-1);
		int ans=0;
		for(i=0;i<n;i++){
			used.assign(n,false);
			if(try_kuhn(i))
				ans++;
		}
		cout<<ans<<endl;
	}
	
	return 0;
}