// 402_3  1

#include <cstdio>
#include <algorithm>
#include <iostream>
#include <memory>
#include <vector>
#include <cmath>
#include <map>

using namespace std;

int per[3][4] ={
	{2,3,4,5},
	{1,3,4,6},
	{1,2,5,6},
};

int toq[] = {0,0,1,2,2,1,0};

//typedef map<pos, long long> mp;
//mp c;
vector<vector<vector<long long> > > c;
vector<vector<int> > v; 

int m, n;

long long f(int x, int y, int q)
{
	long long t = c[x][y][q];
	if(t!=-1e17)
		return t;
	if(x==m-1 && y==n-1)
		return 0;
	long long s = -1e17;
	if(x<m-1)
	{
		if(v[y][x+1]<0)
		{
			for(int i = 0; i<2; ++i)
			{
				long long w = v[y][x+1]*per[q][i]+f(x+1, y, toq[per[q][i]]);
				if(w>s)
					s = w;
			}
		}
		else
		{
			for(int i = 2; i<4; ++i)
			{
				long long w = v[y][x+1]*per[q][i]+f(x+1, y, toq[per[q][i]]);
				if(w>s)
					s = w;
			}
		}
	}
	if(y<n-1)
	{
		if(v[y+1][x]<0)
		{
			for(int i = 0; i<2; ++i)
			{
				long long w = v[y+1][x]*per[q][i]+f(x, y+1, toq[per[q][i]]);
				if(w>s)
					s = w;
			}
		}
		else
		{
			for(int i = 2; i<4; ++i)
			{
				long long w = v[y+1][x]*per[q][i]+f(x, y+1, toq[per[q][i]]);
				if(w>s)
					s = w;
			}
		}
	}
	return t = c[x][y][q] = s;
}

void solve()
{
	cin>>n>>m;
	c.clear();
	c.resize(m);
	for(int i = 0; i<m; ++i)
	{
		c[i].resize(n);
		for(int j = 0; j<n; ++j)
			c[i][j].assign(3, -1e17);
	}
	v.clear();
	v.assign(n, vector<int>(m));
	for(int i = 0; i<n; ++i)
	{
		for(int j = 0; j<m; ++j)
			scanf("%d",&v[i][j]);
	}
	long long s = -1e17;
	for(int i = 0; i<6; ++i)
	{
		long long t = f(0,0,toq[i+1])+v[0][0]*(i+1);
		if(t>s)
			s = t;
	}
	cout<<s<<'\n';
}

int main()
{
	freopen("dice.in","r",stdin);
	int t;
	scanf("%d",&t);
	while(t--)
		solve();
}

//void solve()
//{
//	/*
//	long long k;
//	int p1, p2, p3;
//	cin>>k>>p1>>p2>>p3;
//	long double t1 = (long double)p1/100;
//	long double t2 = (long double)p2/100;
//	long double t3 = (long double)p3/100;
//	long double a = (2*t2-1)*k/(2*t1-2*t2+t3-0.5);
//	long long q = floor(a+0.5+1e-9);
//	if(q==k)
//		--q;
//	cout<<q<<'\n';
//*/
//}