#include <iostream>
#include <algorithm>
#include <memory.h>
#include <stdio.h>

#define max(a,b) ((a)>(b)?(a):(b))
#define min(a,b) ((a)<(b)?(a):(b))
using namespace std;


int c[1111],a[1111];
int D[1111],L[1111],H[1111];
inline double timeWithSpeed(int curM, int N)
{
    double sum_time = 0;
    for (int i =0; i < N; i++)
    {
        double curT = (double)D[i] / curM + (curM > L[i] ? H[i] : 0);
        sum_time += curT;
    }
    return sum_time;
}
int main()
{
    freopen("BUS.IN","r",stdin);

    int t,n,M,N;
    cin>>t;
    while (t--)
    {
        cin >> N >> M;
        for (int i = 0; i < N; i++)
        {
            cin >> D[i] >> L[i] >> H[i];
        }
        int Mmax = M;
        double Tmin = timeWithSpeed(Mmax, N);

        for (int i =0; i <N; i++)
        {
            int curM = L[i];
            if (curM >= M) continue;
            double sum_time = timeWithSpeed(curM, N);
            if (sum_time < Tmin || ((Tmin - sum_time) < 0.001 && curM > Mmax))
            {
                Mmax = curM;
                Tmin = sum_time;
            }
        }
        cout << Mmax<<endl;
    }

    return 0;
}
