// 402_3  1

#include <cstdio>
#include <algorithm>
#include <iostream>
#include <memory>
#include <vector>
#include <cmath>
#include <map>

using namespace std;

int per[3][4] ={
	{2,3,4,5},
	{1,3,4,6},
	{1,2,5,6},
};

int toq[] = {0,0,1,2,2,1,0};

struct pos
{
	int x, y, q;
	pos(int a, int b, int c):x(a),y(b),q(c) {}
	bool operator<(const pos &o) const
	{
		if(x<o.x)
			return 1;
		if(x>o.x)
			return 0;
		if(y<o.y)
			return 1;
		if(y>o.y)
			return 0;
		return q<o.q;
	}
};

map<pos, long long> c;
vector<vector<int> > v; 

int m, n;

long long f(pos a)
{
	long long &t = c[a];
	if(t)
		return t;
	if(a.x==m-1 && a.y==n-1)
		return 0;
	long long s = -1e17;
	if(a.x<m-1)
	{
		for(int i = 0; i<4; ++i)
		{
			long long w = v[a.x+1][a.y]*per[a.q][i]+f(pos(a.x+1, a.y, toq[per[a.q][i]]));
			if(w>s)
				s = w;
		}
	}
	if(a.y<n-1)
	{
		for(int i = 0; i<4; ++i)
		{
			long long w = v[a.x][a.y+1]*per[a.q][i]+f(pos(a.x, a.y+1, toq[per[a.q][i]]));
			if(w>s)
				s = w;
		}
	}
	return t = s;
}

void solve()
{
	c.clear();
	cin>>n>>m;
	v.assign(n, vector<int>(m));
	for(int i = 0; i<n; ++i)
	{
		for(int j = 0; j<m; ++j)
			cin>>v[i][j];
	}
	long long s = 1e-17;
	for(int i = 0; i<6; ++i)
	{
		long long t = f(pos(0,0,toq[i+1]))+v[0][0]*(i+1);
		if(t>s)
			s = t;
	}
	cout<<s<<'\n';
}

int main()
{
	freopen("dice.in","r",stdin);
	int t;
	scanf("%d",&t);
	while(t--)
		solve();
}

//void solve()
//{
//	/*
//	long long k;
//	int p1, p2, p3;
//	cin>>k>>p1>>p2>>p3;
//	long double t1 = (long double)p1/100;
//	long double t2 = (long double)p2/100;
//	long double t3 = (long double)p3/100;
//	long double a = (2*t2-1)*k/(2*t1-2*t2+t3-0.5);
//	long long q = floor(a+0.5+1e-9);
//	if(q==k)
//		--q;
//	cout<<q<<'\n';
//*/
//}