#include <iostream>

using namespace std;

class heap
{
private:
	struct sheet
	{
		int num;
		sheet *link;
	}*top, *cur;
	int amount;
public:
	heap()
	{
		top=NULL;
		cur=NULL;
		amount=0;
	}
	void push(int num)
	{
		if (top == NULL)
		{
			top = new sheet;
			top->num = num;
			top->link = NULL;
			cur = top;
		}else{
			sheet *k;
			k=top;
			if (top->link == NULL)
				if (num >= k->num)
				{
					top = new sheet;
					top->num = num;
					top->link = k;
				}else{
					top->link = new sheet;
					top->link->num = num;
					top->link->link = NULL;
				}
			else
				if (num >= k->num)
				{
					top = new sheet;
					top->num = num;
					top->link = k;
				}else{
					sheet *tmp;
					bool fl=false;
					while (k->link != NULL)
					{
						if (num >= k->link->num)
						{
							tmp = new sheet;
							tmp->num = num;
							tmp->link = k->link;
							k->link = tmp;
							fl=true;
							break;
						}
						k=k->link;
					}
					if (!fl)
					{
						tmp = new sheet;
						tmp->num = num;
						tmp->link = k->link;
						k->link = tmp;
					}
				}
		}
		amount++;
	}
	int Get()
	{
		if (top == NULL) return 0;
		amount--;
		int znach;
		sheet *vrem;
		vrem=top;
		znach = top->num;
		top = top->link;
		delete vrem;
		return znach;
	}
	void Clear()
	{
		amount=0;
		while (top != NULL)
		{
			sheet *vrem;
			vrem=top;
			top = top->link;
			delete vrem;
		}
	}
};

int main() {
	
	freopen("GRAPHIC.IN", "r", stdin);
	int t, N;
	cin >> t;
	heap heap1;
	while (t--) {
		int T[1010],C[1010];
		int curday=0;
		int sum=0;
		cin >> N;
		for (int i=0; i<N; i++)
		{
			cin >> T[i] >> C[i];
			if (curday < T[i]) curday = T[i];
		}
		bool fl=false;
		int k=1;
		do{
			fl=false;
			for (int i=0; i<N-k; i++)
			{
				int tmp;
				if (T[i] < T[i+1])
				{
					tmp=T[i];
					T[i]=T[i+1];
					T[i+1]=tmp;
					tmp=C[i];
					C[i]=C[i+1];
					C[i+1]=tmp;
					fl=true;
				}
			}
			k++;
		} while(fl);
		T[N]=-1;
		for (int i=0; i<N; i++)
		{
			heap1.push(C[i]);
			if (T[i] != T[i+1])
			{
				if (T[i+1] == -1)
					for (int j=0; j<T[i]; j++)
						sum += heap1.Get();
				else
					for (int j=0; j<T[i]-T[i+1]; j++)
						sum += heap1.Get();
			}
		}
		heap1.Clear();
		cout << sum << endl;

	}
	return 0;
}		