#include <iostream>
#include <stack>

using namespace std;

void main()
{
	freopen("BUS.IN", "r", stdin);

	int T;

	cin >> T;

	for (int i = 0; i < T; i++)
	{
		int N, M;
		cin >> N >> M;

		int masD[1000];
		int masL[1000];
		int masH[1000];		

		for (int j = 0; j < N; j++)
		{
			cin >> masD[j] >> masL[j] >> masH[j];
		}
		
		int min = 0;
		for (int curSeg = 0; curSeg < N; curSeg++)
		{
			min += masD[curSeg];
		}
		
		float bestSpeed;

		stack<int> masSpeed;

		for (int j = 0; j < N; j++)
			masSpeed.push(masL[j]);

		masSpeed.push(M);	

		while (!masSpeed.empty())
		{
			float t = 0;

			float curS = masSpeed.top();
			masSpeed.pop();

			for (int curSeg = 0; curSeg < N; curSeg++)
			{
				t += masD[curSeg] / curS ;
				if (curS > masL[curSeg])
					t += masH[curSeg];
			}

			if (t < min)
			{
				min = t;
				bestSpeed = curS;
			}
		}
		
		cout << (int)bestSpeed << endl;		
	}	

	return;
}