#include <iostream>
#include <cmath>

using namespace std;


int main() {
	freopen("JOUST.IN", "r", stdin);
	//freopen("OUT.TXT", "w+", stdout);


	int t;
	cin >> t;
	while (t--) {
		__int64 k, p11, p22, p33;
		cin >> k >> p11 >> p22 >> p33;
		double p1 = p11 / 100., p2 = p22 / 100., p3 = p33 / 100.;
		double n = (k * (2 * p2 - 1)) / ((2 * p1 + 2 * p2 + p3 - 2) * 1.);
		if (n < 1)
			n = 1;
		else
			if (n > k - 1)
				n = k - 1;
			else
			{
				__int64 n1 = (__int64) n;
				__int64 n2 = ((__int64) n) + 1;
				double fn1 = n1 * (2 * p1 + 2 * p2 + p3 - 2) + k * (1 - 2 * p2);
				double fn2 = n2 * (2 * p1 + 2 * p2 + p3 - 2) + k * (1 - 2 * p2);
				if (fabs(fn1) < fabs(fn2))
					n = n1;
				else
					n = n2;
			}
			cout << (__int64) n << endl;
	}

	return 0;
}		