#include <iostream>
#include <fstream>
#include <vector>
#include <string.h>
#include <algorithm>

using namespace std;

vector<int>* data;
bool flag;

int* d;
int* f;
int* color;
int n;
int currentTime;
int component;

void DFSVisit(int u);

void DFS()
{
  d=new int[n+1];
  f=new int[n+1];
  color=new int[n+1];
  memset(d,0,sizeof(int)*(n+1));
  memset(f,0,sizeof(int)*(n+1));
  memset(color,0,sizeof(int)*(n+1));
  currentTime=0;
  if(flag)
    component=0;
  //cout<<component<<endl;
  for(int i=1; i<=n; i++)
  {
    if(color[i]==0)
    {
      if(flag)
        component++;
      DFSVisit(i);
    }
  }
}

void DFSVisit(int u)
{
  d[u]=++currentTime;
  color[u]=1;
  for(unsigned int i=0; i<data[u].size(); i++)
  {
    if(color[data[u][i]]==0)
    {
      DFSVisit(data[u][i]);
    }
  }
  color[u]=2;
  f[u]=++currentTime;
}

bool comp(int a, int b)
{
  return f[a]>f[b];
}

int main()
{
  ifstream strm("IGUANA.IN");
  int QWE;
  strm>>QWE;
  for(int T=0; T<QWE; T++)
  {
    strm>>n;
    data=new vector<int>[n+1];
    for(int i=1; i<=n; i++)
    {
      for(int j=1; j<=n; j++)
      {
        int tmp;
        strm>>tmp;
        if(tmp==0 && j>=i)
          data[i].push_back(j);
      }
    }
    flag=false;
    DFS();
    vector<int>* dataTmp=new vector<int>[n+1];
    for(int i=1; i<=n; i++)
    {
      for(unsigned int j=0; j<data[i].size(); j++)
        dataTmp[data[i][j]].push_back(i);
    }
    data=dataTmp;
    for(int i=1; i<=n; i++)
    {
      sort(data[i].begin(),data[i].end(),comp);
    }
    flag=true;
    DFS();
    cout<<component<<endl;
  }

  return 0;
}