#include <iostream>
#include <stack>

using namespace std;

void main()
{
	freopen("BUS.IN", "r", stdin);

	short T;

	cin >> T;

	for (int i = 0; i < T; i++)
	{
		short N;
		double M;
		cin >> N >> M;

		double masD[1001];
		double masL[1001];
		double masH[1001];		

		for (int j = 0; j < N; j++)
		{
			cin >> masD[j] >> masL[j] >> masH[j];
		}
		
		double min = 0;
		for (int curSeg = 0; curSeg < N; curSeg++)
		{
			min += masD[curSeg];
		}
		
		double bestSpeed;

		stack<double> masSpeed;

		masSpeed.push(M);	
		for (int j = 0; j < N; j++)
			masSpeed.push(masL[j]);		

		while (!masSpeed.empty())
		{
			double t = 0;

			double curS = masSpeed.top();
			masSpeed.pop();

			for (int curSeg = 0; curSeg < N; curSeg++)
			{
				t += masD[curSeg] / curS ;
				if (curS > masL[curSeg])
					t += masH[curSeg];
			}

			if (t < min)
			{
				min = t;
				bestSpeed = curS;
			}
		}
		
		cout << bestSpeed << endl;		
	}	

	return;
}